package eu.javaspecialists.tutorials.util;

import java.util.*;

public class PerformanceComparison {
  public static void main(String... args) {
    Collection<List<Integer>> lists = Arrays.<List<Integer>>asList(
        new ArrayList<Integer>(),
        new CircularArrayList<Integer>()
    );
    lists.forEach(list -> {
      for (int i = 0; i < 100_000; i++) {
        list.add(i);
      }
    });

    for (int i = 0; i < 10; i++) {
      lists.forEach(PerformanceComparison::test);
    }
  }

  private static void test(List<Integer> list) {
    System.out.println(list.getClass());
    long time = System.currentTimeMillis();
    long addRemoves = 0;
    while(System.currentTimeMillis() - time < 1000) {
      for (int i = 0; i < 1000; i++) {
        list.add(42);
        list.remove(0);
        addRemoves++;
      }
    }
    time = System.currentTimeMillis() - time;
    System.out.println("time = " + time + "ms");
    System.out.printf(Locale.US, "addRemoves = %,d%n", addRemoves);
  }
}
